import navigo from "navigo";
import { readable, writable } from "svelte/store";
import { SvelteComponent } from "svelte/internal";

export const router = new navigo(null, true);

export type ActiveRoute<T = any> = {
    mobile: typeof SvelteComponent,
    desktop: typeof SvelteComponent,
    params: T
}

let setComponent: (val: ActiveRoute) => void;
export const pageStore = readable<ActiveRoute>(undefined, (set) => {
    setComponent = (val) => {
        console.log(val);
        set(val);
    };
    router.resolve();
});

import VaultsMobile from "./views/Overview.svelte";
import VaultsDesktop from "./views/Overview.svelte";

router.on("/", (params) => {
    setComponent({
        desktop: VaultsDesktop as typeof SvelteComponent,
        mobile: VaultsMobile as typeof SvelteComponent,
        params
    })
})

//   .on("/:vaultid", (params) => {
//     console.log("Route", params);
//     setComponent({
//         desktop: VaultDesktop as typeof SvelteComponent,
//         mobile: VaultMobile as typeof SvelteComponent,
//         params
//     })
// }).on("/:vaultid/:noteid", (params) => {
//     setComponent({
//         desktop: NoteDesktop as typeof SvelteComponent,
//         mobile: NoteMobile as typeof SvelteComponent,
//         params
//     })
// }).on("/settings", (params) => {
//     setComponent({
//         desktop: SettingsDesktop as typeof SvelteComponent,
//         mobile: SettingsMobile as typeof SvelteComponent,
//         params
//     })
// }).on("/share", (params) => {
//     setComponent({
//         desktop: ShareDesktop as typeof SvelteComponent,
//         mobile: ShareMobile as typeof SvelteComponent,
//         params
//     })
// })